/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1997 Electrotechnical Laboratry (ETL), AIST, MITI

Permission to use, copy, modify, and distribute this material for any
purpose and without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies, and
that the name of ETL not be used in advertising or publicity pertaining
to this material without the specific, prior written permission of an
authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	windows0.c
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	970211	extracted from windows.c
//////////////////////////////////////////////////////////////////////#*/
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifndef LE
#define LE 1?0:
#define LT 1?0:
#define LV 1?0:
#define LW 1?0:
#endif

#ifdef _MSC_VER

fork(){
	LT("fork() NOT SUPPORTED");
	exit(1);
}

/* ######## PIPE ######## */
int pipe(sv)
	int sv[2];
{	int rcode;

	rcode = _pipe(sv,4096,O_BINARY);
	LW("pipe() = %d [%d,%d]",rcode,sv[0],sv[1]);
	return rcode;
}
FILE *popen(command,mode)
	char *command,*mode;
{
	LV("popen(%s,%s)",command,mode);
	return _popen(command,mode);
}
pclose(fp)
	FILE *fp;
{
	LV("pclose(%x)",fp);
	return _pclose(fp);
}

fcntl(fd){
	LE("fcntl(%d) NOT SUPPORTED",fd);
	return -1;
}
ftruncate(fd,size)
{	int rcode;

	rcode = chsize(fd,size);
	LV("ftruncate(%d,%d) = %d",fd,size,rcode);
	return rcode;
}

static char *tmpfiles[512];
static int tmpfilex;
extern int errno;
static deltmpfiles()
{	int ti;
	char *path;
	int rcode;
	int fd;

	for( fd = 3; fd < 256; fd++ ){
		if( 0 < _get_osfhandle(fd) ){
			rcode = _close(fd);
			LW("exit: close(%d) = %d",fd,rcode);
		}
	}
	for( ti = 0;  path = tmpfiles[ti]; ti++ ){
		errno = 0;
		rcode = unlink(path);
		LV("unlink(%s) = %d, errno=%d",path,rcode,errno);
	}
}
FILE *fopentmpfile(path)
	char *path;
{	FILE *fp;
	int fd;

	fd = _open(path,O_CREAT|O_TEMPORARY|O_RDWR|O_BINARY,S_IREAD|S_IWRITE);
	if( 0 <= fd ){
		if( fp = _fdopen(fd,"w+b") ){
			tmpfiles[tmpfilex++] = strdup(path);
			LV("fopentmpfile(%s) %x / %d",path,fp,fileno(fp));
		}else	LE("cannot fdopen(%d) %s",fd,path);
	}else{
		LE("cannot open(%d)",path);
		fp = NULL;
	}
	return fp;
}

static int isWindows = 1;
#else
static int isWindows = -1;

FILE *fopentmpfile(path)
	char *path;
{	FILE *fp;

	if( fp = fopen(path,"w+") )
		unlink(path);
	return fp;
}
#endif

IsWindows(){
	return 0 < isWindows;
}
IsWindows95(){
	return IsWindows() && getpid() < 0;
}
